function AppViewAssistant(item)
{
	this.item = item;
}

AppViewAssistant.prototype.setup = function()
{
	// setup command menu
	this.cmdMenuModel =
	{
		label: $L('Menu'), 
		items: [
			{label: $L('Back'), icon:'back', command: 'back'},
			{label: $L('Do Something!'), command: 'do'},
			{label: $L('Info'), icon:'info', command: 'info'}
		]
	};
	this.controller.setupWidget(Mojo.Menu.commandMenu, undefined, this.cmdMenuModel);
	
	// setup app title
	this.controller.get('appTitle').innerHTML = this.item.Description;
	
	// temporary print app data
	var appData = 'bleh';
	this.controller.get('appData').innerHTML = appData;
}

AppViewAssistant.prototype.handleCommand = function(event)
{
	if(event.type == Mojo.Event.command)
	{
		switch (event.command)
		{
			case 'back':
				this.controller.stageController.popScene();
				break;
				
			case 'do':
				this.controller.showAlertDialog({
				    onChoose: function(value) {},
				    title: $L("Do Something!"),
				    message: 'This is where that something we\'re supposed to do will be done.',
				    choices:[{label:$L('Ok'), value:""}]
			    });
				break;
				
			case 'info':
				this.controller.showAlertDialog({
				    onChoose: function(value) {},
				    title: $L("Info"),
				    message: 'Version: ' + this.item.Version,
				    choices:[{label:$L('Ok'), value:""}]
			    });
				break;
				
			default:
				// this shouldn't happen
				break;
		}
	}
}

AppViewAssistant.prototype.activate = function(event) {}

AppViewAssistant.prototype.deactivate = function(event) {}

AppViewAssistant.prototype.cleanup = function(event) {}
