function ToggleVfsAssistant() {}

/* Variables */
appName = "Toggle VFS";

ToggleVfsAssistant.prototype.setup = function() {
	/* Widgets */
	this.buttonAttributes = {}
	this.controller.setupWidget('btn_mount',
		this.atts = {type: Mojo.Widget.activityButton},
		this.model = {
			label: 'Mount',
			buttonClass: 'affirmative'
		});
	this.controller.setupWidget('btn_unmount',
		this.atts = {type: Mojo.Widget.activityButton},
		this.model = {
			label: 'Unmount',
			buttonClass: 'negative'
		});
	this.controller.setupWidget("btn_donate",
		this.buttonAttributes,
		this.buttonModel = {
			label: 'Donate'
		});
	this.controller.setupWidget("btn_chkserv",
		this.buttonAttributes,
		this.buttonModel = {
			label: 'Check Service'
		});

	this.callDeactivateSpinner = this.callDeactivateSpinner.bind(this);
	Mojo.Event.listen(this.controller.get('btn_mount'), Mojo.Event.tap, this.callDeactivateSpinner);
	Mojo.Event.listen(this.controller.get('btn_unmount'), Mojo.Event.tap, this.callDeactivateSpinner);
	this.controller.listen($('btn_donate'), Mojo.Event.tap, this.donate.bind(this));
	this.controller.listen($('btn_chkserv'), Mojo.Event.tap, this.serviceCheck.bind(this));
}

ToggleVfsAssistant.prototype.mount = function (event) {
    this.controller.serviceRequest('palm://org.webosinternals.optloopservice', {
		method: 'mount',
		parameters: {}
	});
}

ToggleVfsAssistant.prototype.unmount = function (event) {
    this.controller.serviceRequest('palm://org.webosinternals.optloopservice', {
		method: 'unmount',
		parameters: {}
	});
}

ToggleVfsAssistant.prototype.donate = function (event) {
	this.controller.serviceRequest('palm://com.palm.applicationManager', {
		method: "open",
		parameters: {
			id: 'com.palm.app.browser',
			params: {
				target: "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=7411252"
			}
		}
	});
}

ToggleVfsAssistant.prototype.serviceCheck = function (event) {
	this.controller.serviceRequest('palm://org.webosinternals.optloopservice', {
		method: "version",
		parameters: {},
		onSuccess: this.handleServiceCheck.bind(this),
		onFailure: this.handleServiceCheckFailure.bind(this)
	});
}

ToggleVfsAssistant.prototype.handleMount = function(response) {
	$('log').update(response.output_mount_success);
}

ToggleVfsAssistant.prototype.handleMountFailure = function(response) {
	$('log').update(response.output.mount_failure);
}

ToggleVfsAssistant.prototype.handleServiceCheck = function(response) {
	if (response.general[0].name !== undefined
	 && response.general[1].version !== undefined)
		this.controller.showAlertDialog({
			title: $L("Service Info"),
			message: $L("The current version of " + appName + "'s " + response.general[0].name + " is " + response.general[1].version + "."),
			choices: [{label: $L('OK')}]
		});
	else
		this.handleServiceCheckFailure();
}

ToggleVfsAssistant.prototype.handleServiceCheckFailure = function(response) {
	this.controller.showAlertDialog({
		title: $L("Error"),
		message: $L("The service appears to be deprecated, malformed, or missing! Please download the latest version from Gitorious and reinstall."),
		choices: [{label: $L('OK')}]
	});
}

ToggleVfsAssistant.prototype.callDeactivateSpinner = function() {
	if (!this.spinning) {
		window.setInterval(this.deactivateSpinner.bind(this), 1000);
		this.spinning = true;
	}
}

ToggleVfsAssistant.prototype.deactivateSpinner = function() {
	this.buttonWidget = this.controller.get('btn_mount');
	this.buttonWidget.mojo.deactivate();
	this.spinning = false;
	this.buttonWidget = this.controller.get('btn_unmount');
	this.buttonWidget.mojo.deactivate();
	this.spinning = false;
}

ToggleVfsAssistant.prototype.activate = function(event) {
	/* Put in event handlers here that should only be in effect when this scene is active. For example, key handlers that are observing the document. */
	if (this.controller.stageController.setWindowOrientation) {
		this.controller.stageController.setWindowOrientation("free");
	}
}

ToggleVfsAssistant.prototype.deactivate = function(event) {
	/* Remove any event handlers you added in activate and do any other cleanup that should happen before this scene is popped or another scene is pushed on top. */
}

ToggleVfsAssistant.prototype.cleanup = function(event) {
	/* This function should do any cleanup needed before the scene is destroyed as a result of being popped off the scene stack. */
	Mojo.Event.stopListening(this.controller.get('btn_mount'),Mojo.Event.tap, this.callDeactivateSpinner);
	Mojo.Event.stopListening(this.controller.get('btn_unmount'),Mojo.Event.tap, this.callDeactivateSpinner);
}